package com.sanjagh.sanjagh_flutter;

import android.content.Context;
import android.view.View;

import com.sanjagh.sdk.AdListener;
import com.sanjagh.sdk.BannerAdView;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.platform.PlatformView;

public class BannerView implements PlatformView, MethodChannel.MethodCallHandler, AdListener {
    private final BannerAdView bannerAdView;
    private final MethodChannel methodChannel;

    BannerView(Context context, BinaryMessenger messenger, int id, String adUnitId) {
        bannerAdView = new BannerAdView(context,adUnitId);
        bannerAdView.setAdListener(this);
        methodChannel = new MethodChannel(messenger, "com.sanjagh.sdk/banner_" + id);
        methodChannel.setMethodCallHandler(this);
    }

    @Override
    public View getView() {
        return bannerAdView;
    }

    @Override
    public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {
        switch (methodCall.method) {
            case "setText":
                setText(methodCall, result);
                break;
            default:
                result.notImplemented();
        }

    }

    private void setText(MethodCall methodCall, MethodChannel.Result result) {
        String text = (String) methodCall.arguments;
        result.success(null);
    }
    private Map<String, Object> argumentsMap(Object... args) {
        Map<String, Object> arguments = new HashMap<String, Object>();
        for (int i = 0; i < args.length; i += 2) arguments.put(args[i].toString(), args[i + 1]);
        return arguments;
    }
    @Override
    public void dispose() {}

    @Override
    public void onAdLoaded() {
        methodChannel.invokeMethod("onAdLoaded", null);
    }

    @Override
    public void onAdFailedToLoad(int errorCode) {
        methodChannel.invokeMethod("onAdFailedToLoad",argumentsMap("errorCode", errorCode));
    }

    @Override
    public void onNoAd() {
        methodChannel.invokeMethod("onNoAd", null);
    }

    @Override
    public void onNoNetwork() {
        methodChannel.invokeMethod("onNoNetwork",null);
    }

}
